Index: /XIOS/dev/dev_olga/src/parse_expr/lex_parser.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/lex_parser.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/lex_parser.cpp	(revision 1158)
@@ -1134,10 +1176,5 @@
 /* Amount of stuff to slurp up with each read. */
 #ifndef YY_READ_BUF_SIZE
-#ifdef __ia64__
-/* On IA-64, the buffer size is 16k, not 8k */
-#define YY_READ_BUF_SIZE 16384
-#else
 #define YY_READ_BUF_SIZE 8192
-#endif /* __ia64__ */
 #endif
 
@@ -1224,4 +1261,9 @@
 	register int yy_act;
     
+#line 29 "lex_parser.lex"
+
+
+#line 1267 "lex_parser.cpp"
+
 	if ( !(yy_init) )
 		{
@@ -1249,10 +1291,4 @@
 		yy_load_buffer_state( );
 		}
-
-	{
-#line 29 "lex_parser.lex"
-
-
-#line 1257 "lex_parser.cpp"
 
 	while ( 1 )		/* loops until end-of-file is reached */
@@ -1388,23 +1424,38 @@
 case 16:
 YY_RULE_SETUP
-#line 68 "lex_parser.lex"
-return LEFT_PARENTHESIS;
+#line 67 "lex_parser.lex"
+return NE;
 	YY_BREAK
 case 17:
 YY_RULE_SETUP
-#line 69 "lex_parser.lex"
-return RIGHT_PARENTHESIS;
+#line 68 "lex_parser.lex"
+return QUESTION_MARK;
 	YY_BREAK
 case 18:
 YY_RULE_SETUP
-#line 71 "lex_parser.lex"
-return END;
+#line 69 "lex_parser.lex"
+return COLON;
 	YY_BREAK
 case 19:
 YY_RULE_SETUP
-#line 72 "lex_parser.lex"
+#line 70 "lex_parser.lex"
+return LEFT_PARENTHESIS;
+	YY_BREAK
+case 20:
+YY_RULE_SETUP
+#line 71 "lex_parser.lex"
+return RIGHT_PARENTHESIS;
+	YY_BREAK
+case 21:
+YY_RULE_SETUP
+#line 73 "lex_parser.lex"
+return END;
+	YY_BREAK
+case 22:
+YY_RULE_SETUP
+#line 74 "lex_parser.lex"
 ECHO;
 	YY_BREAK
-#line 1409 "lex_parser.cpp"
+#line 1460 "lex_parser.cpp"
 case YY_STATE_EOF(INITIAL):
 	yyterminate();
@@ -1537,5 +1588,4 @@
 	} /* end of action switch */
 		} /* end of scanning one token */
-	} /* end of user's declarations */
 } /* end of yylex */
 
@@ -2166,5 +2216,5 @@
 	char *buf;
 	yy_size_t n;
-	yy_size_t i;
+	int i;
     
 	/* Get memory for full buffer, including space for trailing EOB's. */
@@ -2396,3 +2446,3 @@
 #define YYTABLES_NAME "yytables"
 
-#line 71 "lex_parser.lex"
+#line 74 "lex_parser.lex"
Index: /XIOS/dev/dev_olga/src/parse_expr/lex_parser.lex
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/lex_parser.lex	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/lex_parser.lex	(revision 1158)
@@ -65,5 +65,7 @@
 "<=" return LE;
 ">=" return GE;
-
+"/=" return NE;
+"?" return QUESTION_MARK;
+":" return COLON;
 "("  return LEFT_PARENTHESIS;
 ")"  return RIGHT_PARENTHESIS;
Index: /XIOS/dev/dev_olga/src/parse_expr/operator_expr.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/operator_expr.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/operator_expr.hpp	(revision 1158)
@@ -17,9 +17,17 @@
     typedef double (*functionScalar)(double);
     typedef double (*functionScalarScalar)(double, double);
+    typedef double (*functionScalarScalarScalar)(double, double,double);
     typedef CArray<double,1> (*functionField)(const CArray<double,1>&);
     typedef CArray<double,1> (*functionFieldField)(const CArray<double,1>&, const CArray<double,1>&);
     typedef CArray<double,1> (*functionFieldScalar)(const CArray<double,1>&, double);
     typedef CArray<double,1> (*functionScalarField)(double, const CArray<double,1>&);
-
+    typedef CArray<double,1> (*functionScalarScalarField)(double, double, const CArray<double,1>&);
+    typedef CArray<double,1> (*functionScalarFieldScalar)(double, const CArray<double,1>&, double);
+    typedef CArray<double,1> (*functionScalarFieldField)(double, const CArray<double,1>&, const CArray<double,1>&);
+    typedef CArray<double,1> (*functionFieldScalarScalar)(const CArray<double,1>&, double, double);
+    typedef CArray<double,1> (*functionFieldScalarField)(const CArray<double,1>&, double, const CArray<double,1>&);
+    typedef CArray<double,1> (*functionFieldFieldScalar)(const CArray<double,1>&,  const CArray<double,1>&, double);
+    typedef CArray<double,1> (*functionFieldFieldField)(const CArray<double,1>&,  const CArray<double,1>&, const CArray<double,1>&);
+    
     COperatorExpr(void)
     {
@@ -43,5 +51,7 @@
       opScalarScalar[string("le")] = le_ss;
       opScalarScalar[string("ge")] = ge_ss;
-
+      opScalarScalar[string("ne")] = ne_ss;
+      opScalarScalarScalar[string("cond")] = cond_sss;
+      
       opField[string("neg")] = neg_f;
       opField[string("cos")] = cos_f;
@@ -63,4 +73,5 @@
       opFieldField[string("le")] = le_ff;
       opFieldField[string("ge")] = ge_ff;
+      opFieldField[string("ne")] = ne_ff;
 
       opFieldScalar[string("add")] = add_fs;
@@ -74,4 +85,5 @@
       opFieldScalar[string("le")] = le_fs;
       opFieldScalar[string("ge")] = ge_fs;
+      opFieldScalar[string("ne")] = ne_fs;
 
       opScalarField[string("add")] = add_sf;
@@ -84,4 +96,15 @@
       opScalarField[string("le")] = le_sf;
       opScalarField[string("ge")] = ge_sf;
+      opScalarField[string("ne")] = ne_sf;
+
+      opScalarScalarField[string("cond")] = cond_ssf;
+      opScalarFieldScalar[string("cond")] = cond_sfs;
+      opScalarFieldField[string("cond")] = cond_sff;
+      opFieldScalarScalar[string("cond")] = cond_fss;
+      opFieldScalarField[string("cond")] = cond_fsf;
+      opFieldFieldScalar[string("cond")] = cond_ffs;
+      opFieldFieldField[string("cond")] = cond_fff;
+
+
     }
 
@@ -102,4 +125,12 @@
     }
 
+    functionScalarScalarScalar getOpScalarScalarScalar(const string& id)
+    {
+      map<string,double (*)(double,double,double)>::iterator it;
+      it = opScalarScalarScalar.find(id);
+      if (it == opScalarScalarScalar.end()) ERROR("functionScalarScalarScalar getOpScalarScalarScalar(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
     functionField getOpField(const string& id)
     {
@@ -134,10 +165,77 @@
     }
 
+    functionScalarScalarField getOpScalarScalarField(const string& id)
+    {
+      map<string,functionScalarScalarField>::iterator it;
+      it = opScalarScalarField.find(id);
+      if (it == opScalarScalarField.end()) ERROR("functionScalarScalarField getOpScalarScalarField(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionScalarFieldScalar getOpScalarFieldScalar(const string& id)
+    {
+      map<string,functionScalarFieldScalar>::iterator it;
+      it = opScalarFieldScalar.find(id);
+      if (it == opScalarFieldScalar.end()) ERROR("functionScalarFieldScalar getOpScalarScalarField(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionScalarFieldField getOpScalarFieldField(const string& id)
+    {
+      map<string,functionScalarFieldField>::iterator it;
+      it = opScalarFieldField.find(id);
+      if (it == opScalarFieldField.end()) ERROR("functionScalarFieldField getOpScalarFieldField(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionFieldScalarScalar getOpFieldScalarScalar(const string& id)
+    {
+      map<string,functionFieldScalarScalar>::iterator it;
+      it = opFieldScalarScalar.find(id);
+      if (it == opFieldScalarScalar.end()) ERROR("functionFieldScalarScalar getOpFieldScalarScalar(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionFieldScalarField getOpFieldScalarField(const string& id)
+    {
+      map<string,functionFieldScalarField>::iterator it;
+      it = opFieldScalarField.find(id);
+      if (it == opFieldScalarField.end()) ERROR("functionFieldScalarField getOpFieldScalarField(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionFieldFieldScalar getOpFieldFieldScalar(const string& id)
+    {
+      map<string,functionFieldFieldScalar>::iterator it;
+      it = opFieldFieldScalar.find(id);
+      if (it == opFieldFieldScalar.end()) ERROR("functionFieldFieldScalar getOpFieldFieldScalar(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+
+    functionFieldFieldField getOpFieldFieldField(const string& id)
+    {
+      map<string,functionFieldFieldField>::iterator it;
+      it = opFieldFieldField.find(id);
+      if (it == opFieldFieldField.end()) ERROR("functionFieldFieldField getOpFieldFieldField(const string& id)", << "unknown operator : " << id)
+      return it->second;
+    }
+    
+    
     map<string,functionScalar> opScalar;
     map<string,functionScalarScalar> opScalarScalar;
+    map<string,functionScalarScalarScalar> opScalarScalarScalar;
     map<string,functionField> opField;
     map<string,functionFieldField> opFieldField;
     map<string,functionFieldScalar> opFieldScalar;
     map<string,functionScalarField> opScalarField;
+    map<string,functionScalarScalarField> opScalarScalarField;
+    map<string,functionScalarFieldScalar> opScalarFieldScalar;
+    map<string,functionScalarFieldField> opScalarFieldField;
+    map<string,functionFieldScalarScalar> opFieldScalarScalar;
+    map<string,functionFieldScalarField> opFieldScalarField;
+    map<string,functionFieldFieldScalar> opFieldFieldScalar;
+    map<string,functionFieldFieldField> opFieldFieldField;
+
+
 
     static inline double neg_s(double x)   { return -x; }
@@ -160,4 +258,5 @@
     static inline double le_ss(double x, double y)    { return x <= y; }
     static inline double ge_ss(double x, double y)    { return x >= y; }
+    static inline double ne_ss(double x, double y)    { return x != y; }
 
     static inline CArray<double,1> neg_f(const CArray<double,1>& x)   { return Array<double,1>(-x); }
@@ -180,4 +279,5 @@
     static inline CArray<double,1> le_ff(const CArray<double,1>& x, const CArray<double,1>& y)    { return Array<double,1>(x <= y); }
     static inline CArray<double,1> ge_ff(const CArray<double,1>& x, const CArray<double,1>& y)    { return Array<double,1>(x >= y); }
+    static inline CArray<double,1> ne_ff(const CArray<double,1>& x, const CArray<double,1>& y)    { return Array<double,1>(x != y); }
 
     static inline CArray<double,1> add_fs(const CArray<double,1>& x, double y)   { return Array<double,1>(x + y); }
@@ -191,4 +291,5 @@
     static inline CArray<double,1> le_fs(const CArray<double,1>& x, double y)    { return Array<double,1>(x <= y); }
     static inline CArray<double,1> ge_fs(const CArray<double,1>& x, double y)    { return Array<double,1>(x >= y); }
+    static inline CArray<double,1> ne_fs(const CArray<double,1>& x, double y)    { return Array<double,1>(x != y); }
 
     static inline CArray<double,1> add_sf(double x, const CArray<double,1>& y)   { return Array<double,1>(x + y); }
@@ -201,4 +302,70 @@
     static inline CArray<double,1> le_sf(double x, const CArray<double,1>& y)    { return Array<double,1>(x <= y); }
     static inline CArray<double,1> ge_sf(double x, const CArray<double,1>& y)    { return Array<double,1>(x >= y); }
+    static inline CArray<double,1> ne_sf(double x, const CArray<double,1>& y)    { return Array<double,1>(x != y); }
+
+
+    static inline double cond_sss(double x, double y, double z)   { return (x==0) ? z : y ; }
+
+    static inline CArray<double,1> cond_ssf(double x, double y, const CArray<double,1>& z)
+    {
+      CArray<double,1> ret(z.numElements()) ;
+      if (x==0) ret=z ;
+      else ret=y ;
+      return ret ;
+    }
+
+    static inline CArray<double,1> cond_sfs(double x, const CArray<double,1>& y, double z)
+    {
+      CArray<double,1> ret(y.numElements()) ;
+     if (x==0) ret=z ;
+      else ret=y ;
+      return ret ;
+    }
+
+    static inline CArray<double,1> cond_sff(double x, const CArray<double,1>& y, const CArray<double,1>& z)
+    {
+      CArray<double,1> ret(y.numElements()) ;
+      if (x==0) ret=z ;
+      else ret=y ;
+      return ret ;
+    }
+    
+    static inline CArray<double,1> cond_fss(const CArray<double,1>& x, double y, double z)
+    {
+      CArray<double,1> ret(x.numElements()) ;
+      Array<double,1>::const_iterator itx=x.begin(),itxe=x.end();
+      Array<double,1>::iterator itret=ret.begin() ;
+      
+      for(;itx!=itxe;++itx,++itret) *itret=( (*itx==0)?z:y) ;
+      return ret ;
+    }
+
+    static inline CArray<double,1> cond_fsf(const CArray<double,1>& x, double y, const CArray<double,1>& z)
+    {
+      CArray<double,1> ret(x.numElements()) ;
+      Array<double,1>::const_iterator itx=x.begin(), itxe=x.end(), itz=z.begin();
+      Array<double,1>::iterator itret=ret.begin() ;
+      for(;itx!=itxe;++itx,++itz,++itret) *itret=( (*itx==0)?*itz:y) ;
+      return ret ;
+    }
+
+    static inline CArray<double,1> cond_ffs(const CArray<double,1>& x, const CArray<double,1>& y, double z)
+    {
+      CArray<double,1> ret(x.numElements()) ;
+      Array<double,1>::const_iterator itx=x.begin(), itxe=x.end(), ity=y.begin() ;
+      Array<double,1>::iterator itret=ret.begin() ;
+      for(;itx!=itxe;++itx,++ity,++itret) *itret=( (*itx==0)?z:*ity) ;
+      return ret ;
+    }
+
+    static inline CArray<double,1> cond_fff(const CArray<double,1>& x, const CArray<double,1>& y, const CArray<double,1>&  z)
+    {
+      CArray<double,1> ret(x.numElements()) ;
+      Array<double,1>::const_iterator itx=x.begin(), itxe=x.end(), ity=y.begin(), itz=z.begin() ;
+      Array<double,1>::iterator itret=ret.begin() ;
+      for(;itx!=itxe;++itx,++ity,++itz,++itret) *itret=( (*itx==0)?*itz:*ity) ;
+      return ret ;
+    }
+
   };
 
Index: /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.cpp	(revision 1158)
@@ -23,8 +23,16 @@
   double CScalarVarExprNode::reduce() const
   {
-    if (!CVariable::has(varId)) 
-      ERROR("double CScalarVarExprNode::reduce() const", << "The variable " << varId << " does not exist.");
+    // $missing_value will be replaced with NaN
+    if (varId == "missing_value")
+    {
+      return std::numeric_limits<double>::quiet_NaN();
+    }
+    else
+    {
+      if (!CVariable::has(varId)) 
+        ERROR("double CScalarVarExprNode::reduce() const", << "The variable " << varId << " does not exist.");
 
-    return CVariable::get(varId)->getData<double>();
+      return CVariable::get(varId)->getData<double>();
+    }
   }
 
@@ -59,3 +67,21 @@
     return op(child1->reduce(), child2->reduce());
   }
+
+
+  CScalarTernaryOpExprNode::CScalarTernaryOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("CScalarTernaryOpExprNode::CScalarTernaryOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  double CScalarTernaryOpExprNode::reduce() const
+  {
+    COperatorExpr::functionScalarScalarScalar op = operatorExpr.getOpScalarScalarScalar(opId);
+    return op(child1->reduce(), child2->reduce(), child3->reduce());
+  }
 }
Index: /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/scalar_expr_node.hpp	(revision 1158)
@@ -107,4 +107,25 @@
       boost::scoped_ptr<IScalarExprNode> child1, child2; //!< The scalar child nodes to which the operator is applied
   };
+
+    class CScalarTernaryOpExprNode : public IScalarExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided scalar child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param opId the identifier of the operator
+       * \param child1, child2 , child3 the scalar child nodes to which the operator is applied
+       */
+      CScalarTernaryOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3);
+
+      double reduce() const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IScalarExprNode> child1, child2, child3; //!< The scalar child nodes to which the operator is applied
+  };
 }
 
